package assistedinject;

import static java.lang.annotation.ElementType.PARAMETER;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * The <code>@Assisted</code> annotation should be used on paramters within
 * a constructor annotated with <code>@AssistedInject</code>.  The annotation
 * indicates that the parameter will be supplied through a factory method (the
 * parameter will not be injected by Guice).
 * 
 * @author <a href="jmourits@gmail.com">Jerome Mourits</a>
 * @author <a href="jesse@swank.ca">Jesse Wilson</a>
 */
@Target({PARAMETER})
@Retention(RUNTIME)
public @interface Assisted {}