package assistedinject;

import static java.lang.annotation.ElementType.CONSTRUCTOR;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

/**
 * Constructors annotated with <code>@AssistedInject</code> indicate that will
 * can be instantiated by the {@link FactoryProvider}.  Each constructor must
 * exactly one corresponding factory method within the Factory Interface.
 * 
 * <p>Constructor parameters must be either supplied by the Factory Interface and
 * marked with <code>@Assisted</code>, or they must be injectable.
 * 
 * @author <a href="jmourits@gmail.com">Jerome Mourits</a>
 * @author <a href="jesse@swank.ca">Jesse Wilson</a>
 */
@Target({CONSTRUCTOR})
@Retention(RUNTIME)
public @interface AssistedInject {}